using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;

namespace BalloonTest
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private CPSearchForm searchForm;
		private System.Windows.Forms.CheckedListBox options;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.TextBox caption;
		private System.Windows.Forms.TextBox content;
		private System.Windows.Forms.Button showBalloon;
		private System.Windows.Forms.Button close;
		private System.Windows.Forms.ComboBox iconFile;
		private System.Windows.Forms.Label anchor;
		private System.Windows.Forms.Button showForm;
		private Balloon.NET.BalloonHelp balloonHelp;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			
			options.Items.AddRange( new object[] {
													"CloseOnDeactivate",
													"CloseOnMouseMove",
													"CloseOnMouseClick",
													"CloseOnKeyPress",
													"EnableTimeout",
													"ShowCloseButton"});
			
			options.SetItemChecked(0, true);
			options.SetItemChecked(4, true);
			options.SetItemChecked(5, true);
		}
		
		private void RecreateBalloon(object sender, EventArgs e)
		{
			balloonHelp = new Balloon.NET.BalloonHelp();
			balloonHelp.Disposed += new EventHandler(this.RecreateBalloon);
			showBalloon.Enabled = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
				
				if ((balloonHelp != null) && !balloonHelp.IsDisposed)
					balloonHelp.Dispose();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.caption = new System.Windows.Forms.TextBox();
			this.content = new System.Windows.Forms.TextBox();
			this.showBalloon = new System.Windows.Forms.Button();
			this.close = new System.Windows.Forms.Button();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.anchor = new System.Windows.Forms.Label();
			this.options = new System.Windows.Forms.CheckedListBox();
			this.label1 = new System.Windows.Forms.Label();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.iconFile = new System.Windows.Forms.ComboBox();
			this.label5 = new System.Windows.Forms.Label();
			this.showForm = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// caption
			// 
			this.caption.Location = new System.Drawing.Point(8, 24);
			this.caption.Name = "caption";
			this.caption.Size = new System.Drawing.Size(152, 20);
			this.caption.TabIndex = 0;
			this.caption.Text = "Sample Caption";
			// 
			// content
			// 
			this.content.Location = new System.Drawing.Point(8, 72);
			this.content.Multiline = true;
			this.content.Name = "content";
			this.content.Size = new System.Drawing.Size(152, 96);
			this.content.TabIndex = 1;
			this.content.Text = "Sample Text\r\nText can have multiple lines";
			// 
			// showBalloon
			// 
			this.showBalloon.Location = new System.Drawing.Point(344, 24);
			this.showBalloon.Name = "showBalloon";
			this.showBalloon.Size = new System.Drawing.Size(88, 23);
			this.showBalloon.TabIndex = 8;
			this.showBalloon.Text = "&Show Balloon";
			this.showBalloon.Click += new System.EventHandler(this.showBalloon_Click);
			// 
			// close
			// 
			this.close.Location = new System.Drawing.Point(344, 112);
			this.close.Name = "close";
			this.close.Size = new System.Drawing.Size(88, 23);
			this.close.TabIndex = 9;
			this.close.Text = "Close";
			this.close.Click += new System.EventHandler(this.close_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 11;
			this.label2.Text = "&Caption";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 56);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 12;
			this.label3.Text = "Con&tent";
			// 
			// anchor
			// 
			this.anchor.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.anchor.Location = new System.Drawing.Point(344, 64);
			this.anchor.Name = "anchor";
			this.anchor.Size = new System.Drawing.Size(88, 32);
			this.anchor.TabIndex = 13;
			this.anchor.Text = "Balloon Will be Anchored here";
			// 
			// options
			// 
			this.options.Location = new System.Drawing.Point(168, 72);
			this.options.Name = "options";
			this.options.Size = new System.Drawing.Size(160, 94);
			this.options.TabIndex = 14;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(168, 56);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 15;
			this.label1.Text = "&Options";
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.Filter = "Icon Files|*.ico";
			// 
			// iconFile
			// 
			this.iconFile.Items.AddRange(new object[] {
														  "SystemIcons.Error",
														  "SystemIcons.Exclamation",
														  "SystemIcons.Warning",
														  "SystemIcons.Question",
														  "Browse.."});
			this.iconFile.Location = new System.Drawing.Point(168, 24);
			this.iconFile.Name = "iconFile";
			this.iconFile.Size = new System.Drawing.Size(160, 21);
			this.iconFile.TabIndex = 16;
			this.iconFile.SelectedIndexChanged += new System.EventHandler(this.comboBox1_SelectedIndexChanged);
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(168, 8);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(100, 16);
			this.label5.TabIndex = 17;
			this.label5.Text = "&Icon";
			// 
			// showForm
			// 
			this.showForm.Location = new System.Drawing.Point(344, 144);
			this.showForm.Name = "showForm";
			this.showForm.Size = new System.Drawing.Size(88, 32);
			this.showForm.TabIndex = 18;
			this.showForm.Text = "&Show Balloon Form";
			this.showForm.Click += new System.EventHandler(this.showForm_Click);
			// 
			// MainForm
			// 
			this.AcceptButton = this.showBalloon;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(442, 184);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.showForm,
																		  this.label5,
																		  this.iconFile,
																		  this.label1,
																		  this.options,
																		  this.anchor,
																		  this.label3,
																		  this.label2,
																		  this.close,
																		  this.showBalloon,
																		  this.content,
																		  this.caption});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "MainForm";
			this.Text = "Balloon Help Demo";
			this.ResumeLayout(false);

		}
		#endregion

		private void searchForm_Disposed(object sender, System.EventArgs e)
		{
			searchForm = null;
		}

		static void Main(string[] args)
		{
			Application.Run(new MainForm());
		}

		private void comboBox1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (iconFile.SelectedIndex == -1)
				return;
			
			if (iconFile.SelectedItem.ToString() == "Browse..")
			{
				if (openFileDialog1.ShowDialog(this) != DialogResult.Cancel)
				{
					iconFile.SelectedIndex = iconFile.Items.Add(openFileDialog1.FileName);
				}
			}
				
		}

		private void showBalloon_Click(object sender, System.EventArgs e)
		{
			try
			{
				RecreateBalloon(this, EventArgs.Empty);

				balloonHelp.Caption = this.caption.Text;
				balloonHelp.Content = this.content.Text;
				
				switch(iconFile.Text)
				{
					case "":
						balloonHelp.Icon = null;
						break;
					case "SystemIcons.Error":
						balloonHelp.Icon = SystemIcons.Error;
						break;
					case "SystemIcons.Exclamation":
						balloonHelp.Icon = SystemIcons.Exclamation;
						break;
					case "SystemIcons.Warning":
						balloonHelp.Icon = SystemIcons.Warning;
						break;
					case "SystemIcons.Question":
						balloonHelp.Icon = SystemIcons.Question;
						break;
					default:
						balloonHelp.Icon = new Icon(iconFile.Text);
						break;
				}
			
				//Now get the options
				int max = options.Items.Count;

				for(int i = 0; i < max; i++)
				{
					PropertyInfo pi = typeof(Balloon.NET.BalloonHelp).GetProperty(options.Items[i].ToString());
					pi.SetValue(balloonHelp, options.GetItemChecked(i), null);
				}
				
				balloonHelp.ShowBalloon(anchor);
				showBalloon.Enabled = false;
			}
			catch(Exception ex)
			{
				MessageBox.Show(this, ex.ToString());
			}
		}

		private void close_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		private void showForm_Click(object sender, System.EventArgs e)
		{
			if (searchForm != null)
				return;

			searchForm = new CPSearchForm();
			searchForm.Disposed += new EventHandler(this.searchForm_Disposed);
			searchForm.ShowBalloon(anchor);
		}
	}
}
