/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace EventReminder
{
	/// <summary>
	/// Description rsume de FormEventEdit.
	/// </summary>
	public class FormEventEdit : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label_name;
		private System.Windows.Forms.Label label_event;
		private System.Windows.Forms.Label label_read_messagge;
		private System.Windows.Forms.Label label_day_before;
		private System.Windows.Forms.Label label_date;
		private System.Windows.Forms.Label label_phone;
		private System.Windows.Forms.Label label_email;
		private System.Windows.Forms.TextBox textBox_name;
		private System.Windows.Forms.TextBox textBox_event;
		private System.Windows.Forms.TextBox textBox_read_message;
		private System.Windows.Forms.DateTimePicker dateTimePicker;
		private System.Windows.Forms.NumericUpDown numericUpDown_day_before;
		private System.Windows.Forms.TextBox textBox_phone;
		private System.Windows.Forms.TextBox textBox_mail;
		private System.Windows.Forms.Button button_prev;
		private System.Windows.Forms.Button button_next;
		private System.Windows.Forms.Button button_save;
		private System.Windows.Forms.Button button_cancel;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private single_event[] array_single_event;
		private int index_array_single_event;
		private single_event old_event;

		public FormEventEdit()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
			Class_MakeXPStyle.MakeXPStyle(this);
			this.button_next.Visible=false;
			this.button_prev.Visible=false;
		}

		public void event_to_edit(single_event[] array_single_event)
		{
			this.array_single_event=array_single_event;
			if (array_single_event.Length>1)
			{
				this.button_next.Visible=true;
				this.button_prev.Visible=true;
				this.button_prev.Enabled=false;
			}
			index_array_single_event=0;
			load_single_event(array_single_event[0]);
		}

		public void event_to_edit(single_event the_single_event)
		{
			load_single_event(the_single_event);
		}

		private void load_single_event(single_event the_event)
		{
			this.textBox_event.Text=the_event.event_description;
			this.textBox_mail.Text=the_event.email;
			this.textBox_name.Text=the_event.name;
			this.textBox_phone.Text=the_event.phone;
			this.textBox_read_message.Text=the_event.message_to_read;
			this.dateTimePicker.Text =new System.DateTime(System.DateTime.Now.Year,the_event.date.month,the_event.date.day).ToShortDateString();
			this.numericUpDown_day_before.Value=the_event.day_before;

			this.old_event=the_event;
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormEventEdit));
			this.label_name = new System.Windows.Forms.Label();
			this.label_event = new System.Windows.Forms.Label();
			this.label_read_messagge = new System.Windows.Forms.Label();
			this.label_day_before = new System.Windows.Forms.Label();
			this.label_date = new System.Windows.Forms.Label();
			this.label_phone = new System.Windows.Forms.Label();
			this.label_email = new System.Windows.Forms.Label();
			this.textBox_name = new System.Windows.Forms.TextBox();
			this.textBox_event = new System.Windows.Forms.TextBox();
			this.textBox_read_message = new System.Windows.Forms.TextBox();
			this.dateTimePicker = new System.Windows.Forms.DateTimePicker();
			this.numericUpDown_day_before = new System.Windows.Forms.NumericUpDown();
			this.textBox_phone = new System.Windows.Forms.TextBox();
			this.textBox_mail = new System.Windows.Forms.TextBox();
			this.button_prev = new System.Windows.Forms.Button();
			this.button_next = new System.Windows.Forms.Button();
			this.button_save = new System.Windows.Forms.Button();
			this.button_cancel = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_day_before)).BeginInit();
			this.SuspendLayout();
			// 
			// label_name
			// 
			this.label_name.Location = new System.Drawing.Point(36, 56);
			this.label_name.Name = "label_name";
			this.label_name.Size = new System.Drawing.Size(72, 23);
			this.label_name.TabIndex = 0;
			this.label_name.Text = "Name :";
			// 
			// label_event
			// 
			this.label_event.Location = new System.Drawing.Point(36, 79);
			this.label_event.Name = "label_event";
			this.label_event.TabIndex = 1;
			this.label_event.Text = "Event :";
			// 
			// label_read_messagge
			// 
			this.label_read_messagge.Location = new System.Drawing.Point(36, 102);
			this.label_read_messagge.Name = "label_read_messagge";
			this.label_read_messagge.TabIndex = 2;
			this.label_read_messagge.Text = "Message read :";
			// 
			// label_day_before
			// 
			this.label_day_before.Location = new System.Drawing.Point(36, 148);
			this.label_day_before.Name = "label_day_before";
			this.label_day_before.Size = new System.Drawing.Size(120, 23);
			this.label_day_before.TabIndex = 3;
			this.label_day_before.Text = "Day before to warn :";
			// 
			// label_date
			// 
			this.label_date.Location = new System.Drawing.Point(36, 125);
			this.label_date.Name = "label_date";
			this.label_date.TabIndex = 4;
			this.label_date.Text = "Date :";
			// 
			// label_phone
			// 
			this.label_phone.Location = new System.Drawing.Point(36, 171);
			this.label_phone.Name = "label_phone";
			this.label_phone.TabIndex = 5;
			this.label_phone.Text = "Phone :";
			// 
			// label_email
			// 
			this.label_email.Location = new System.Drawing.Point(36, 194);
			this.label_email.Name = "label_email";
			this.label_email.TabIndex = 6;
			this.label_email.Text = "Email :";
			// 
			// textBox_name
			// 
			this.textBox_name.Location = new System.Drawing.Point(148, 56);
			this.textBox_name.Name = "textBox_name";
			this.textBox_name.Size = new System.Drawing.Size(200, 20);
			this.textBox_name.TabIndex = 7;
			this.textBox_name.Text = "";
			// 
			// textBox_event
			// 
			this.textBox_event.Location = new System.Drawing.Point(148, 76);
			this.textBox_event.Name = "textBox_event";
			this.textBox_event.Size = new System.Drawing.Size(200, 20);
			this.textBox_event.TabIndex = 8;
			this.textBox_event.Text = "";
			// 
			// textBox_read_message
			// 
			this.textBox_read_message.Location = new System.Drawing.Point(148, 96);
			this.textBox_read_message.Name = "textBox_read_message";
			this.textBox_read_message.Size = new System.Drawing.Size(200, 20);
			this.textBox_read_message.TabIndex = 9;
			this.textBox_read_message.Text = "";
			// 
			// dateTimePicker
			// 
			this.dateTimePicker.CustomFormat = "MM/dd";
			this.dateTimePicker.Format = System.Windows.Forms.DateTimePickerFormat.Custom;
			this.dateTimePicker.Location = new System.Drawing.Point(276, 120);
			this.dateTimePicker.Name = "dateTimePicker";
			this.dateTimePicker.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.dateTimePicker.Size = new System.Drawing.Size(72, 20);
			this.dateTimePicker.TabIndex = 10;
			// 
			// numericUpDown_day_before
			// 
			this.numericUpDown_day_before.Location = new System.Drawing.Point(300, 144);
			this.numericUpDown_day_before.Maximum = new System.Decimal(new int[] {
																					 345,
																					 0,
																					 0,
																					 0});
			this.numericUpDown_day_before.Name = "numericUpDown_day_before";
			this.numericUpDown_day_before.Size = new System.Drawing.Size(48, 20);
			this.numericUpDown_day_before.TabIndex = 11;
			this.numericUpDown_day_before.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.numericUpDown_day_before.Value = new System.Decimal(new int[] {
																				   2,
																				   0,
																				   0,
																				   0});
			// 
			// textBox_phone
			// 
			this.textBox_phone.Location = new System.Drawing.Point(148, 168);
			this.textBox_phone.Name = "textBox_phone";
			this.textBox_phone.Size = new System.Drawing.Size(200, 20);
			this.textBox_phone.TabIndex = 12;
			this.textBox_phone.Text = "";
			// 
			// textBox_mail
			// 
			this.textBox_mail.Location = new System.Drawing.Point(148, 192);
			this.textBox_mail.Name = "textBox_mail";
			this.textBox_mail.Size = new System.Drawing.Size(200, 20);
			this.textBox_mail.TabIndex = 13;
			this.textBox_mail.Text = "";
			// 
			// button_prev
			// 
			this.button_prev.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button_prev.Location = new System.Drawing.Point(8, 16);
			this.button_prev.Name = "button_prev";
			this.button_prev.Size = new System.Drawing.Size(40, 23);
			this.button_prev.TabIndex = 14;
			this.button_prev.Text = "<";
			this.button_prev.Click += new System.EventHandler(this.button_prev_Click);
			// 
			// button_next
			// 
			this.button_next.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.button_next.Location = new System.Drawing.Point(336, 16);
			this.button_next.Name = "button_next";
			this.button_next.Size = new System.Drawing.Size(40, 23);
			this.button_next.TabIndex = 15;
			this.button_next.Text = ">";
			this.button_next.Click += new System.EventHandler(this.button_next_Click);
			// 
			// button_save
			// 
			this.button_save.Location = new System.Drawing.Point(107, 232);
			this.button_save.Name = "button_save";
			this.button_save.TabIndex = 16;
			this.button_save.Text = "Save";
			this.button_save.Click += new System.EventHandler(this.button_save_Click);
			// 
			// button_cancel
			// 
			this.button_cancel.Location = new System.Drawing.Point(203, 232);
			this.button_cancel.Name = "button_cancel";
			this.button_cancel.TabIndex = 17;
			this.button_cancel.Text = "Close";
			this.button_cancel.Click += new System.EventHandler(this.button_cancel_Click);
			// 
			// FormEventEdit
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(384, 268);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button_cancel,
																		  this.button_save,
																		  this.button_next,
																		  this.button_prev,
																		  this.textBox_mail,
																		  this.textBox_phone,
																		  this.numericUpDown_day_before,
																		  this.dateTimePicker,
																		  this.textBox_read_message,
																		  this.textBox_event,
																		  this.textBox_name,
																		  this.label_email,
																		  this.label_phone,
																		  this.label_date,
																		  this.label_day_before,
																		  this.label_read_messagge,
																		  this.label_event,
																		  this.label_name});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "FormEventEdit";
			this.ShowInTaskbar = false;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Event";
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown_day_before)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void button_next_Click(object sender, System.EventArgs e)
		{
			index_array_single_event++;
			load_single_event(array_single_event[index_array_single_event]);
			if (index_array_single_event==array_single_event.Length-1) this.button_next.Enabled=false;
			this.button_prev.Enabled=true;
		}

		private void button_prev_Click(object sender, System.EventArgs e)
		{
			index_array_single_event--;
			load_single_event(array_single_event[index_array_single_event]);
			if (index_array_single_event==0) this.button_prev.Enabled=false;
			this.button_next.Enabled=true;
		}

		private void button_cancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void button_save_Click(object sender, System.EventArgs e)
		{
			single_event the_event=new single_event();

			the_event.event_description=this.textBox_event.Text;
			the_event.email=this.textBox_mail.Text;
			the_event.name=this.textBox_name.Text;
			the_event.phone=this.textBox_phone.Text;
			the_event.message_to_read=this.textBox_read_message.Text;
			the_event.day_before=(int)this.numericUpDown_day_before.Value;	
			System.DateTime date=this.dateTimePicker.Value;
			the_event.date=new date_event(date.Month,date.Day);
			if (old_event==null)//add
			{
				FormMain.current_form_main.the_main.add_event(the_event);
			}
			else // edit
			{
				FormMain.current_form_main.the_main.remove_event(old_event);
				FormMain.current_form_main.the_main.add_event(the_event);
			}
			FormMain.current_form_main.the_main.clagent.play("Write");
			FormMain.current_form_main.the_main.clagent.play("WriteReturn");
			System.Windows.Forms.MessageBox.Show(this,"Event Saved","Event",System.Windows.Forms.MessageBoxButtons.OK,
											System.Windows.Forms.MessageBoxIcon.Information);
		}

	}
}
