/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace EventReminder
{
	/// <summary>
	/// Description rsume de FormEventWarning.
	/// </summary>
	public class FormEventWarning : Balloon.NET.BalloonWindow//: System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button_close;
		private System.ComponentModel.IContainer components;
		private int top_position;
		private System.Windows.Forms.ImageList imageList;
		private bool stop_main;
        private bool closing = false;

		public FormEventWarning()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			//
			// TODO : ajoutez le code du constructeur aprs l'appel  InitializeComponent
			//
			top_position=0;
			stop_main=false;
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FormEventWarning));
			this.button_close = new System.Windows.Forms.Button();
			this.imageList = new System.Windows.Forms.ImageList(this.components);
			this.SuspendLayout();
			// 
			// button_close
			// 
			this.button_close.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.button_close.FlatStyle = System.Windows.Forms.FlatStyle.Popup;
			this.button_close.Image = ((System.Drawing.Bitmap)(resources.GetObject("button_close.Image")));
			this.button_close.ImageIndex = 0;
			this.button_close.ImageList = this.imageList;
			this.button_close.Location = new System.Drawing.Point(96, 0);
			this.button_close.Name = "button_close";
			this.button_close.Size = new System.Drawing.Size(14, 14);
			this.button_close.TabIndex = 0;
			this.button_close.Click += new System.EventHandler(this.button_close_Click);
			this.button_close.MouseEnter += new System.EventHandler(this.button_close_MouseEnter);
			this.button_close.MouseLeave += new System.EventHandler(this.button_close_MouseLeave);
			// 
			// imageList
			// 
			this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imageList.ImageSize = new System.Drawing.Size(13, 13);
			this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
			this.imageList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// FormEventWarning
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(112, 46);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button_close});
			this.Name = "FormEventWarning";
			this.Text = "FormEventWarning";
			this.ResumeLayout(false);

		}
		#endregion

		
		public void add_event(string name,string phone,string mail)
		{
			System.Windows.Forms.Label label_name= new System.Windows.Forms.Label();
			System.Windows.Forms.Label label_phone= new System.Windows.Forms.Label();
			System.Windows.Forms.LinkLabel linkLabel_mail= new System.Windows.Forms.LinkLabel();

			label_name.AutoSize = true;
			label_phone.AutoSize = true;
			linkLabel_mail.AutoSize = true;


			label_name.Font= new System.Drawing.Font(System.Drawing.FontFamily.GenericSansSerif,8.25F, System.Drawing.FontStyle.Bold);

			label_name.Text=name;
			label_phone.Text=phone;
			linkLabel_mail.Text=mail;

			// comput location of controls
			label_phone.Left=10;
			linkLabel_mail.Left=10;

			label_name.Top=top_position;
			top_position+=label_name.Height;
			label_phone.Top=top_position;
			top_position+=label_phone.Height;
			linkLabel_mail.Top=top_position;
			top_position+=linkLabel_mail.Height;

			// comput size of the form
			this.Height=top_position+30;

			int the_max=System.Math.Max(this.Width,label_name.Width +label_name.Location.X);
			the_max=System.Math.Max(the_max,label_phone.Width+label_phone.Location.X);
			the_max=System.Math.Max(the_max,linkLabel_mail.Width+linkLabel_mail.Location.X);
			this.Width=the_max;

			// add event to the linkLabel_mail
			linkLabel_mail.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.mail_LinkClicked);
			// add event to the form
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  label_name,
																		  label_phone,
																		  linkLabel_mail});
		}


		private void mail_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			System.Windows.Forms.LinkLabel linkLabel_mail=(System.Windows.Forms.LinkLabel) sender;
			// change color of link
			linkLabel_mail.LinkVisited = true;
			// open mail soft
			string mail;
			string mail_prefix="e-mail: ";
			mail=linkLabel_mail.Text;
			mail=mail.Substring(mail_prefix.Length);
			try
			{
				System.Diagnostics.Process.Start("mailto:"+mail);
			}
			catch (Exception ex)
			{
				System.Windows.Forms.MessageBox.Show( "Error opening default mail client:\r\n"+ex.Message,
					"Error",
					System.Windows.Forms.MessageBoxButtons.OK,
					System.Windows.Forms.MessageBoxIcon.Error);				
			}
		}

		public void close_FormMain_onclose(bool stop_main)
		{
			this.stop_main=stop_main;
		}

		private void button_close_Click(object sender, System.EventArgs e)
		{
            this.closing = true;
			if (stop_main)
				FormMain.current_form_main.Close();
			this.Close();
		}

		private void button_close_MouseEnter(object sender, System.EventArgs e)
		{
			this.button_close.Image=this.imageList.Images[1];
		}

		private void button_close_MouseLeave(object sender, System.EventArgs e)
		{
            // this.Close doesn't remove event handlers but gui content is destroy,
            // so if we don't check the closing state we get an exception at 
            // System.Windows.Forms.ImageList.ImageCollection.get_Item
            // we also could remove handler in button_close_Click
            if (this.closing == false)
			    this.button_close.Image=this.imageList.Images[0];
		}

	}
}
