/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Serialization;

namespace EventReminder
{
	public class XML_access
	{
		/// <summary>
		/// simple sample of call
		/// XMLSerializeObject("samplei.xml",i,typeof(OrderedItem));
		/// sample of call for ArrayList
		/// XMLSerializeObject("sampleal.xml",(OrderedItem[])al.ToArray(typeof(OrderedItem)),typeof(OrderedItem[]));
		/// </summary>
		/// <param name="filename"></param>
		/// <param name="obj"></param>
		/// <param name="typeof_object"></param>
		public static void XMLSerializeObject(string filename,object obj,System.Type typeof_object)
		{
			try
			{
				XmlSerializer serializer = new XmlSerializer(typeof_object);
				// Create an XmlTextWriter using a FileStream.
				Stream fs = new FileStream(filename, FileMode.Create,System.IO.FileAccess.ReadWrite );
				XmlWriter writer = new XmlTextWriter(fs,System.Text.Encoding.Unicode);
				// Serialize using the XmlTextWriter.
				serializer.Serialize(writer, obj);
				writer.Close();
				fs.Close();
			}
			catch(Exception e)
			{
				System.Windows.Forms.MessageBox.Show(e.Message);
			}
		}
		/// <summary>
		/// simple sample of call
		/// OrderedItem i=(OrderedItem)easy_serialize.XMLDeserializeObject("simple.xml",typeof(OrderedItem));
		/// sample of call for ArrayList
		/// System.Collections.ArrayList al=new System.Collections.ArrayList((OrderedItem[])easy_serialize.XMLDeserializeObject("sampleal.xml",typeof(OrderedItem[])));
		/// </summary>
		/// <param name="filename"></param>
		/// <param name="typeof_object"></param>
		/// <returns></returns>
		public static object XMLDeserializeObject(string filename,System.Type typeof_object)
		{   
			// Create an instance of the XmlSerializer specifying type and namespace.
			XmlSerializer serializer = new XmlSerializer(typeof_object);
			// A FileStream is needed to read the XML document.
			FileStream fs = new FileStream(filename, FileMode.Open);
			XmlReader reader = new XmlTextReader(fs);
			// Declare an object variable of the type to be deserialized.
			object obj;
			// Use the Deserialize method to restore the object's state.
			obj = serializer.Deserialize(reader);
			reader.Close();
			fs.Close();
			return obj;
		}
	}
}