/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;

	public class class_TTSMode
	{
		public class_TTSMode(string name,string TTSModeID)
		{
			this.name=name;
			this.TTSModeID=TTSModeID;
		}
		public string name;
		public string TTSModeID;
	}

	public class class_language
	{
		public class_language(string name,int languageID)
		{
			this.name=name;
			this.languageID=languageID;
		}
		public string name;
		public int languageID;
	}


	public class class_language_and_tts_engine
	{
		/// <summary>
		/// get TTSmodeID from TTS name
		/// </summary>
		/// <param name="name"></param>
		/// <returns></returns>
		public static string get_associated_TTSModeID(string name)
		{
			for(int cpt=0;cpt<array_ttsmode.Length;cpt++)
				if (array_ttsmode[cpt].name==name) return array_ttsmode[cpt].TTSModeID;
			// not found return a default ttsID
			return "{CA141FD0-AC7F-11D1-97A3-006008273008}";
		}

		/// <summary>
		/// get languageID from language name
		/// </summary>
		/// <param name="name"></param>
		/// <returns></returns>
		public static int get_associated_languageID(string name)
		{
			for(int cpt=0;cpt<array_language.Length;cpt++)
				if (array_language[cpt].name==name) return array_language[cpt].languageID;
			// not found return a default languageID
			return 0x409;
		}

		#region array filling
		// filling array from msdn reference
		public static string[] array_voice_character={"Normal","Monotone","Whisper"};
		//"Normal"    (Default) A normal tone of voice.
		//"Monotone"    A monotone voice.
		//"Whisper"    A whispered voice.
		public static string[] array_voice_context={"Address","E-mail","Unknown"};
		//"Address"    Addresses and/or phone numbers.
		//"E-mail"    Electronic mail.
		//"Unknown"    (Default) Context is unknown.


		public static class_TTSMode[] array_ttsmode=
		{
			new class_TTSMode("Adult Female #1, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273008}"),
			new class_TTSMode("Adult Female #2, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273009}"),
			new class_TTSMode("Adult Male #1, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273000}"),
			new class_TTSMode("Adult Male #2, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273001}"),
			new class_TTSMode("Adult Male #3, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273002}"),
			new class_TTSMode("Adult Male #4, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273003}"),
			new class_TTSMode("Adult Male #5, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273004}"),
			new class_TTSMode("Adult Male #6, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273005}"),
			new class_TTSMode("Adult Male #7, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273006}"),
			new class_TTSMode("Adult Male #8, US English, L&H TruVoice", "{CA141FD0-AC7F-11D1-97A3-006008273007}"),
			new class_TTSMode("Carol, British English, L&H TTS3000", "{227A0E40-A92A-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Peter, British English, L&H TTS3000", "{227A0E41-A92A-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Linda, Dutch, L&H TTS3000", "{A0DDCA40-A92C-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Alexander, Dutch, L&H TTS3000", "{A0DDCA41-A92C-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Vronique, French, L&H TTS3000", "{0879A4E0-A92C-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Pierre, French, L&H TTS3000", "{0879A4E1-A92C-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Anna, German, L&H TTS3000", "{3A1FB760-A92B-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Stefan, German, L&H TTS3000", "{3A1FB761-A92B-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Barbara, Italian, L&H TTS3000", "{7EF71700-A92D-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Stefano, Italian, L&H TTS3000", "{7EF71701-A92D-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Naoko, Japanese, L&H TTS3000", "{A778E060-A936-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Kenji, Japanese, L&H TTS3000", "{A778E061-A936-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Shin-Ah, Korean, L&H TTS3000", "{12E0B720-A936-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Jun-Ho, Korean, L&H TTS3000", "{12E0B721-A936-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Juliana, Portuguese (Brazil), L&H TTS3000", "{8AA08CA0-A1AE-11d3-9BC5-00A0C967A2D1}"),
			new class_TTSMode("Alexandre, Portuguese (Brazil), L&H TTS3000", "{8AA08CA1-A1AE-11d3-9BC5-00A0C967A2D1}"),
			new class_TTSMode("Svetlana, Russian, L&H TTS3000", "{06377F80-D48E-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Boris, Russian, L&H TTS3000", "{06377F81-D48E-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Carmen, Spanish, L&H TTS3000", "{2CE326E0-A935-11d1-B17B-0020AFED142E}"),
			new class_TTSMode("Julio, Spanish, L&H TTS3000", "{2CE326E1-A935-11d1-B17B-0020AFED142E}")
		};
		// filling array from msdn reference
		public static class_language[] array_language = 
		{
			new class_language("Arabic", 0x401),
			new class_language("Basque", 0x42D),
			new class_language("Chinese(Simplified)", 0x804),
			new class_language("Chinese (Traditional)", 0x404),
			new class_language("Croatian", 0x41A),
			new class_language("Czech", 0x405),
			new class_language("Danish", 0x406),
			new class_language("Dutch", 0x413),
			new class_language("English (British)", 0x809),
			new class_language("English (US)", 0x409),
			new class_language("Finnish", 0x40B),
			new class_language("French", 0x40C),
			new class_language("German ", 0x407),
			new class_language("Greek", 0x408),
			new class_language("Hebrew", 0x40D),
			new class_language("Hungarian", 0x40E),
			new class_language("Italian", 0x410),
			new class_language("Japanese", 0x411),
			new class_language("Korean", 0x412),
			new class_language("Norwegian", 0x414),
			new class_language("Polish", 0x415),
			new class_language("Portuguese (Portugal)", 0x816),
			new class_language("Portuguese (Brazil)", 0x416),
			new class_language("Romanian", 0x418),
			new class_language("Russian", 0x419),
			new class_language("Slovakian", 0x41B),
			new class_language("Slovenian", 0x424),
			new class_language("Spanish", 0xC0A),
			new class_language("Swedish", 0x41D),
			new class_language("Thai", 0x41E),
			new class_language("Turkish", 0x41F)
		};
		#endregion
	}
