/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;
namespace EventReminder
{
	public class class_options
	{
		#region const
		private const string option_filename="options.xml";
		public const string task_name="SpeakingEventReminder";
		#endregion

		#region members

		public string language;
		public string tts_engine;
		public string agent_name;
		public bool language_engine;//true if language is fixed by tts_engine, false if language is fixed by languageID
		public bool ballon_on;
		public string voice_context;
		public string voice_character;
		public int voice_speed;
		public int voice_pitch;
		public bool default_voice;

		public bool play_message_if_noevent_at_windows_startup;
		public bool play_welcome_message;
		public string no_event_speech;
		public string n_days_before_event;

		public bool shortcut_launch;// true if launch at startup, false if with windows task
        public ushort task_day_interval;
		public ushort task_start_hour;
		public ushort task_start_min;

		#endregion

		#region constructors
		public class_options()
		{
			language="English (US)";
			tts_engine="Adult Female #1, US English, L&H TruVoice";
			agent_name = "";//default character
			language_engine=false;
			ballon_on=true;
			voice_context="Unknown";
			voice_character="Normal";
			voice_speed=150;
			voice_pitch=150;
			default_voice=true;

			play_message_if_noevent_at_windows_startup=true;
			play_welcome_message=true;
			n_days_before_event="_n_days days before _event";
			no_event_speech="No events in the following days...";

			shortcut_launch=true;
			task_day_interval=1;
			task_start_hour=14;
			task_start_min=0;
		}

		#endregion

		#region methodes

		public static class_options load()
		{
			try
			{
				string file_name=get_folder_name()+"\\"+option_filename;
				return (class_options)XML_access.XMLDeserializeObject(file_name,typeof(class_options));
			}
			catch// in any case of error (file not found...) create a new class option with default value
			{
				return new class_options();
			}
		}

		public void save()
		{
			string file_name=get_folder_name()+"\\"+option_filename;
			XML_access.XMLSerializeObject(file_name,this,typeof(class_options));
		}

		private static string get_folder_name()
		{
			string exename=System.Windows.Forms.Application.ExecutablePath;
			exename = exename.Replace('/', '\\'); // ExecutablePath is happy to return a mix between '/' and '\\' ... thank you ms for this buggy stuff
			return exename.Substring(0,exename.LastIndexOf("\\"));
		}

		#endregion
	}
}