/******************************************************************************************************************
*	Author:				Jacquelin POTIER
*	Date:				10/31/2002
*	Copyright:			 2002, Jacquelin POTIER (jacquelin.potier@libertysurf.fr). 
*                                       Free for non commercial use (please let author's name)
/******************************************************************************************************************/
using System;

namespace EventReminder
{
	public class single_event
	{
		public single_event()
		{
			name="";
			event_description="";
			message_to_read="";
			email="";
			phone="";
			date=new date_event(1,1);
			day_before=2;
		}
		public single_event(string name,string event_description,string message_to_read,date_event date,int day_before,string email,string phone)
		{
			this.name=name;
			this.event_description=event_description;
			this.message_to_read=message_to_read;
			this.date=date;
			this.day_before=day_before;
			this.email=email;
			this.phone=phone;
		}

		public string name;
		public string event_description;
		public string message_to_read;
		public string email;
		public string phone;
		public date_event date;
		public int day_before;

	}


    public class date_event
	{
		public date_event()
		{
			this.month=1;
			this.day=1;
		}
		public date_event(int month,int day)
		{
			this.month=month;
			this.day=day;
		}
		public int month;
		public int day;

		public string tostring()
		{
			return month+"/"+day;
		}

		public static bool operator == (date_event x, date_event y)
		{
			if ((x.day==y.day) && (x.month==y.month)) return true;
			return false;
		}
		public static bool operator != (date_event x, date_event y)
		{
			if (x==y) return false;
			return true;
		}
	}

	public class single_event_with_day_remaining:single_event
	{
		public int day_remaining;

		public single_event_with_day_remaining(single_event se,int remaining_days)
		{
			this.date=se.date;
			this.day_before=se.day_before;
			this.email=se.email;
			this.event_description=se.event_description; 
			this.message_to_read=se.message_to_read;
			this.name=se.name;
			this.phone=se.phone;
			this.day_remaining=remaining_days;
		}
	}

	/// <summary>
	/// Description rsume de events_to_remind.
	/// </summary>
	public class class_events_to_remind
	{
		private const string xml_filename="events.xml";

		public System.Collections.ArrayList al_events; // arrylist of single_event

		public void load()
		{
			try
			{
				string file_name=get_folder_name()+"\\"+xml_filename;
				al_events=new System.Collections.ArrayList((single_event[])XML_access.XMLDeserializeObject(file_name,typeof(single_event[])));
			}
			catch // in any case of error (file not found...)
			{
				al_events=new System.Collections.ArrayList();
			}
		}

		public void save()
		{
			string file_name=get_folder_name()+"\\"+xml_filename;
			XML_access.XMLSerializeObject(file_name,(single_event[])al_events.ToArray(typeof(single_event)),typeof(single_event[]));
		}

		private string get_folder_name()
		{
			string exename=System.Windows.Forms.Application.ExecutablePath;
			exename = exename.Replace('/', '\\'); // ExecutablePath is happy to return a mix between '/' and '\\' ... thank you ms for this buggy stuff
			return exename.Substring(0,exename.LastIndexOf("\\"));
		}
	}

}