// This is the main DLL file.

#include "stdafx.h"
#using <mscorlib.dll>
#include <Shlobj.h>
#include <crtdbg.h>
#include <atldef.h>
#include <atlconv.h>

#include "ShortCut.h"
/*
SW_HIDE Hide the window. 
SW_MINIMIZE Minimize the window. 
SW_RESTORE Activate and display the window. If the window had been previously maximized or minimized, the window will be restored to its original size and position. 
SW_SHOW Activate the window in its current size and position. 
SW_SHOWMAXIMIZED Activate and maximize the window. 
SW_SHOWMINIMIZED Activate and minimize the window. 
SW_SHOWNA Show the window in its current state, but do not activate it. 
SW_SHOWNOACTIVE Show the window in its most recent size and position, but do not activate it. 
SW_SHOWNORMAL Activate and display the window. This style also includes the SW_RESTORE option and will restore the window to its original size and position. 
*/


HRESULT ShortCutLib::ShortCut::_CreateLink(LPCWSTR FilePath, 
    LPCWSTR LnkPath, LPCWSTR LnkDesc,LPCWSTR WorkDir,LPCWSTR pszArgs,int iShowCmd) 
{ 
	USES_CONVERSION;
	CoInitialize(NULL);
    IShellLink* psl; 
	// Get a pointer to the IShellLink interface
    HRESULT  hres = CoCreateInstance(CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *) &psl); 
    if (SUCCEEDED(hres)) 
	{ 
        IPersistFile* ppf; 
         
        psl->SetPath(W2A(FilePath)); 
		psl->SetWorkingDirectory(W2A(WorkDir));
        psl->SetDescription(W2A(LnkDesc)); 
		psl->SetArguments (W2A(pszArgs));//(CW2A(pszArgs));  
		psl->SetShowCmd (iShowCmd);


		// Query IShellLink for the IPersistFile interface for saving the 
       // shortcut in persistent storage. 
        hres = psl->QueryInterface(IID_IPersistFile,(LPVOID*)&ppf); 
 
        if (SUCCEEDED(hres)) 
		{
            WCHAR wsz[MAX_PATH]; 
 
            // Ensure that the string is Unicode. 
            MultiByteToWideChar(CP_ACP, 0, (LPCSTR)LnkPath, -1, 
                wsz, MAX_PATH); 
			// Ensure that the string is Unicode. 
			// Save the link by calling IPersistFile::Save. 
            hres = ppf->Save(LnkPath, TRUE); 
            ppf->Release(); 
        } 
        psl->Release(); 
    }	
	CoUninitialize();
    return hres; 
} 

HRESULT ShortCutLib::ShortCut::_ResolveLink(LPCWSTR LnkFile, LPWSTR FilePath,LPWSTR LnkDesc,LPWSTR WorkDir) 
{ 
	CoInitialize(NULL);
    HRESULT hres; 
    IShellLink* psl; 
	WIN32_FIND_DATA wfd; 
    char strfilepath[MAX_PATH];     
	char strlnkdesc[INFOTIPSIZE];
	char strworkdir[MAX_PATH];

	USES_CONVERSION;
 
    hres = CoCreateInstance(CLSID_ShellLink, NULL, 
        CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *) &psl); 
    if (SUCCEEDED(hres)) 
	{ 
        IPersistFile* ppf;         
        hres = psl->QueryInterface(IID_IPersistFile, (LPVOID *)&ppf); 
        if (SUCCEEDED(hres)) 
		{ 
            hres = ppf->Load(LnkFile, STGM_READ); 
            if (SUCCEEDED(hres)) 
			{               
                hres = psl->Resolve(GetDesktopWindow(), 0); 
                if (SUCCEEDED(hres)) 
				{ 
                    hres = psl->GetPath(strfilepath,MAX_PATH, &wfd, 
                        SLGP_UNCPRIORITY );                                       
					
					if (SUCCEEDED(hres)) 
					{			
						wcscpy(FilePath, A2W(strfilepath)); 
						hres = psl->GetDescription(strlnkdesc,INFOTIPSIZE);						
					}

					if (SUCCEEDED(hres)) 
					{
						wcscpy(LnkDesc,A2W(strlnkdesc));
						hres = psl->GetWorkingDirectory(strworkdir,MAX_PATH);							
					}

					if (SUCCEEDED(hres)) 
					{
						wcscpy(WorkDir,A2W(strworkdir));
					}
                } 
            }         
        ppf->Release(); 
        }     
    psl->Release(); 
    } 
	CoUninitialize();
    return hres; 
} 
