// ShortCut.h

#pragma once

using namespace System;
using namespace System::Runtime::InteropServices;

namespace ShortCutLib
{
	public __gc class ShortCut
	{
		private:
			String* m_filepath;
			String* m_workdir;
			String* m_lnkdesc;
			String* m_lnkpath;
			String* m_pszArgs;
			int m_iShowCmd;

			HRESULT _CreateLink(LPCWSTR FilePath, LPCWSTR LnkPath, LPCWSTR LnkDesc,LPCWSTR WorkDir,LPCWSTR Args,int ShowCmd);
			HRESULT _ResolveLink(LPCWSTR LnkFile, LPWSTR FilePath,LPWSTR LnkDesc,LPWSTR WorkDir);

		public:	 
			__property String* get_FilePath()
			{
				return m_filepath;
			}
			__property void set_FilePath(String *str)
			{
				m_filepath = str;
			}
			__property String* get_WorkDir()
			{
				return m_workdir;
			}
			__property void set_WorkDir(String *str)
			{
				m_workdir = str;
			}
			__property String* get_LnkDesc()
			{
				return m_lnkdesc;
			}
			__property void set_LnkDesc(String *str)
			{
				m_lnkdesc = str;
			}
			__property String* get_LnkPath()
			{
				return m_lnkpath;
			}
			__property void set_LnkPath(String *str)
			{
				m_lnkpath = str;
			}

			__property void set_Args(String *str)
			{
				m_pszArgs = str;
			}

			__property String* get_Args()
			{
				 return m_pszArgs;
			}

			__property void set_ShowCmd(int ShowCmd)
			{
				m_iShowCmd=ShowCmd;
			}
			__property int get_ShowCmd()
			{
				return m_iShowCmd;
			}

			bool CreateLink()
			{
				IntPtr strfilepath = Marshal::StringToCoTaskMemUni(FilePath);
				IntPtr strlnkpath = Marshal::StringToCoTaskMemUni(LnkPath);
				IntPtr strlnkdesc = Marshal::StringToCoTaskMemUni(LnkDesc);
				IntPtr strworkdir = Marshal::StringToCoTaskMemUni(WorkDir);
				IntPtr strparams = Marshal::StringToCoTaskMemUni(Args);

				HRESULT hres = _CreateLink((LPCWSTR)strfilepath.ToPointer(),(LPCWSTR)strlnkpath.ToPointer(),
					(LPCWSTR)strlnkdesc.ToPointer(),(LPCWSTR)strworkdir.ToPointer(),(LPCWSTR)strparams.ToPointer(),ShowCmd);

				Marshal::FreeCoTaskMem(strfilepath);
				Marshal::FreeCoTaskMem(strlnkpath);
				Marshal::FreeCoTaskMem(strlnkdesc);
				Marshal::FreeCoTaskMem(strworkdir);
				Marshal::FreeCoTaskMem(strparams);

				return (hres==S_OK);
			}

			bool ResolveLink()
			{
				wchar_t strfilepath[MAX_PATH];
				wchar_t strworkdir[MAX_PATH];
				wchar_t strlnkdesc[INFOTIPSIZE];

				IntPtr strlnkpath = Marshal::StringToCoTaskMemUni(LnkPath);		 
				
				HRESULT hres = _ResolveLink((LPCWSTR)strlnkpath.ToPointer(),
					strfilepath, strlnkdesc, strworkdir);

				FilePath = strfilepath;
				LnkDesc = strlnkdesc;
				WorkDir = strworkdir;
					
				Marshal::FreeCoTaskMem(strlnkpath);		 

				return (hres==S_OK);
			}
	};
}
