// easy_task.h: interface for the easy_task class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(EASY_TASK_H)
#define EASY_TASK_H

#include <windows.h>
#include <initguid.h>
#include <ole2.h>
#include <mstask.h>
#include <msterr.h>
#include <objidl.h>
#include <wchar.h>
#include <stdio.h>

#define TASK_SUNDAY       (0x1)
#define TASK_MONDAY       (0x2)
#define TASK_TUESDAY      (0x4)
#define TASK_WEDNESDAY    (0x8)
#define TASK_THURSDAY     (0x10)
#define TASK_FRIDAY       (0x20)
#define TASK_SATURDAY     (0x40)
#define TASK_FIRST_WEEK   (1)
#define TASK_SECOND_WEEK  (2)
#define TASK_THIRD_WEEK   (3)
#define TASK_FOURTH_WEEK  (4)
#define TASK_LAST_WEEK    (5)
#define TASK_JANUARY      (0x1)
#define TASK_FEBRUARY     (0x2)
#define TASK_MARCH        (0x4)
#define TASK_APRIL        (0x8)
#define TASK_MAY          (0x10)
#define TASK_JUNE         (0x20)
#define TASK_JULY         (0x40)
#define TASK_AUGUST       (0x80)
#define TASK_SEPTEMBER    (0x100)
#define TASK_OCTOBER      (0x200)
#define TASK_NOVEMBER     (0x400)
#define TASK_DECEMBER     (0x800)
#define TASK_FLAG_INTERACTIVE                  (0x1)
#define TASK_FLAG_DELETE_WHEN_DONE             (0x2)
#define TASK_FLAG_DISABLED                     (0x4)
#define TASK_FLAG_START_ONLY_IF_IDLE           (0x10)
#define TASK_FLAG_KILL_ON_IDLE_END             (0x20)
#define TASK_FLAG_DONT_START_IF_ON_BATTERIES   (0x40)
#define TASK_FLAG_KILL_IF_GOING_ON_BATTERIES   (0x80)
#define TASK_FLAG_RUN_ONLY_IF_DOCKED           (0x100)
#define TASK_FLAG_HIDDEN                       (0x200)
#define TASK_FLAG_RUN_IF_CONNECTED_TO_INTERNET (0x400)
#define TASK_FLAG_RESTART_ON_IDLE_RESUME       (0x800)
#define TASK_FLAG_SYSTEM_REQUIRED              (0x1000)
#define TASK_FLAG_RUN_ONLY_IF_LOGGED_ON        (0x2000)
#define TASK_TRIGGER_FLAG_HAS_END_DATE         (0x1)
#define TASK_TRIGGER_FLAG_KILL_AT_DURATION_END (0x2)
#define TASK_TRIGGER_FLAG_DISABLED             (0x4)
#define	TASK_MAX_RUN_TIMES	( 1440 )

/*
typedef 
enum _TASK_TRIGGER_TYPE
    {	TASK_TIME_TRIGGER_ONCE	= 0,
	TASK_TIME_TRIGGER_DAILY	= 1,
	TASK_TIME_TRIGGER_WEEKLY	= 2,
	TASK_TIME_TRIGGER_MONTHLYDATE	= 3,
	TASK_TIME_TRIGGER_MONTHLYDOW	= 4,
	TASK_EVENT_TRIGGER_ON_IDLE	= 5,
	TASK_EVENT_TRIGGER_AT_SYSTEMSTART	= 6,
	TASK_EVENT_TRIGGER_AT_LOGON	= 7
    }	TASK_TRIGGER_TYPE;
*/

#define EASY_TASK_YEAR_BEGIN    2003
#define EASY_TASK_DAY_BEGIN     1
#define EASY_TASK_MONTH_BEGIN   1

class easy_task  
{
protected:
    ITask *pITask;
    IPersistFile *pIPersistFile;
    ITaskScheduler *pITS;
    WCHAR pwszTaskName[256];
    int get_ITaskScheduler(const char* pc_task_name);
    int activate_task();
    int save_changes();
public:
	easy_task();
	~easy_task();
    int create(const char* pc_task_name);
    int delete_task(const char* pc_task_name);
    bool exist(const char* pc_task_name);
    int set_application(const char* pc_task_name, const char* pc_full_path_exe);
    int set_flags(const char* pc_task_name,DWORD dwflag);
    int set_parameters(const char* pc_task_name,char* parameters);
    int set_account_info(const char* pc_task_name,const char* login,const char* pwd);
    int enable_task_for_logged_user(const char* pc_task_name);

    int set_trigger(const char* pc_task_name,TASK_TRIGGER Trigger);
    int set_daily_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned short days_interval);
    int set_daily_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute);
    int set_monthlydate_bit_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned long days_of_the_month_one_in_bit);
    int set_monthlydate_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned char day_of_the_month);
};

#endif
