#include "easy_task.h"



extern "C" __declspec(dllexport) int create(const char* pc_task_name);
extern "C" __declspec(dllexport) int delete_task(const char* pc_task_name);
extern "C" __declspec(dllexport) bool exist(const char* pc_task_name);
extern "C" __declspec(dllexport) int set_application(const char* pc_task_name, const char* pc_full_path_exe);
extern "C" __declspec(dllexport) int set_flags(const char* pc_task_name,DWORD dwflag);
extern "C" __declspec(dllexport) int set_account_info(const char* pc_task_name,const char* login,const char* pwd);
extern "C" __declspec(dllexport) int enable_task_for_logged_user(const char* pc_task_name);

extern "C" __declspec(dllexport) int set_trigger(const char* pc_task_name,TASK_TRIGGER Trigger);
// extern "c" --> pas de fonction surcharge possible
extern "C" __declspec(dllexport) int set_daily_trigger_with_day_interval(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned short days_interval);
extern "C" __declspec(dllexport) int set_daily_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute);
extern "C" __declspec(dllexport) int set_monthlydate_bit_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned long days_of_the_month_one_in_bit);
extern "C" __declspec(dllexport) int set_monthlydate_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned char day_of_the_month);



extern "C" __declspec(dllexport) int create(const char* pc_task_name)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(et->exist(pc_task_name))
        {
            i=et->delete_task(pc_task_name);
            if (i)
                throw i;
        }
        i=et->create(pc_task_name);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int delete_task(const char* pc_task_name)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(et->exist(pc_task_name))
        {
            i=et->delete_task(pc_task_name);
            throw i;
        }
        throw 0;// error success
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) bool exist(const char* pc_task_name)
{

    easy_task* et=new easy_task();
    bool b;
    b=et->exist(pc_task_name);
    delete et;
    return b;
}
extern "C" __declspec(dllexport) int set_application(const char* pc_task_name, const char* pc_full_path_exe)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_application(pc_task_name,pc_full_path_exe);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_flags(const char* pc_task_name,DWORD dwflag)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_flags(pc_task_name,dwflag);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_account_info(const char* pc_task_name,const char* login,const char* pwd)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_account_info(pc_task_name,login,pwd);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int enable_task_for_logged_user(const char* pc_task_name)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->enable_task_for_logged_user(pc_task_name);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}

extern "C" __declspec(dllexport) int set_trigger(const char* pc_task_name,TASK_TRIGGER Trigger)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_trigger(pc_task_name,Trigger);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_daily_trigger_with_day_interval(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned short days_interval)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_daily_trigger(pc_task_name,start_hour,start_minute,days_interval);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_daily_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_daily_trigger(pc_task_name,start_hour,start_minute);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_monthlydate_bit_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned long days_of_the_month_one_in_bit)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_monthlydate_bit_trigger(pc_task_name,start_hour,start_minute,days_of_the_month_one_in_bit);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_monthlydate_trigger(const char* pc_task_name,unsigned short start_hour,unsigned short start_minute,unsigned char day_of_the_month)
{

    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_monthlydate_trigger(pc_task_name,start_hour,start_minute,day_of_the_month);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}
extern "C" __declspec(dllexport) int set_parameters(const char* pc_task_name,char* parameters)
{
    easy_task* et=new easy_task();
    try
    {
        int i;
        if(!et->exist(pc_task_name))
        {
            i=et->create(pc_task_name);
            if (i)
                throw i;
        }
        i=et->set_parameters(pc_task_name,parameters);
        throw i;
    }
    catch (int i)
    {
        delete et;
        return i;
    }
}