/* @ENF( **********************************************************************/
/******************************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     Nom du logiciel                                              ******/
/******     Nom du projet                                                ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******   Fichier : Cfenetre.cpp                                         ******/
/******   Version : 1.0                                                  ******/
/******   Date cration:28/03/2002     Date dernire modif. : xx/xx/xxxx ******/
/******                                                                  ******/
/******   Liste des composants :                                         ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******                 "copyright, MBDA, 2000 - 2003"                   ******/
/******                                                                  ******/
/******                                                                  ******/
/****** "Ce logiciel est la proprit de MBDA. Il ne peut tre ni        ******/
/******  communiqu  des tiers ni utilis sans autorisation pralable   ******/
/******  crite de MBDA. Son contenu ne peut tre divulgu".             ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******     Description fonctionnelle :                                  ******/
/******     -------------------------                                    ******/
/******                                                                  ******/
/******	    Ce fichier contient la classe Cfenetre                       ******/
/******     affiche un boite de dialogue                                 ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******     Historique :                                                 ******/
/******     ----------                                                   ******/
/******                                                                  ******/
/******************************************************************************/
/******   28/03/2003              Version   1.0                          ******/
/******   Auteur :Jacquelin POTIER Service : M/O/ES/DB/LS                ******/
/******                                                                  ******/
/******   Cration                                                       ******/
/******                                                                  ******/
/******************************************************************************/
/******   xx/xx/yyyy              Version   1.1                          ******/
/******   auteur : ........       Service : ........                     ******/
/******                                                                  ******/
/******       description de la (des)modification(s)                     ******/
/****** ................................................................ ******/
/****** ................................................................ ******/
/******                                                                  ******/
/******************************************************************************/
/******************************************************************************/
/* @ENF) **********************************************************************/
#include "stdafx.h"
#include "Cfenetre.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Cfenetre::Cfenetre()
{
    this->dialogbox_handle=NULL;
    this->owner_handle=NULL;
    this->owner_instance=NULL;
    this->msg=new char[100];
    strcpy(this->msg,"");
    this->caption=new char[100];
    strcpy(this->caption,"");
    this->dw_idd_dialog=IDD_DIALOG_PROGRES;
    g_fen_Cfenetre=this;
}

Cfenetre::Cfenetre(HINSTANCE hi_hInstance,HWND h_owner_handle,DWORD idd_dialog)
{
    this->dialogbox_handle=NULL;
    this->owner_handle=h_owner_handle;
    this->owner_instance=hi_hInstance;
    this->msg=new char[100];
    strcpy(this->msg,"");
    this->caption=new char[100];
    strcpy(this->caption,"");
    this->dw_idd_dialog=idd_dialog;
    g_fen_Cfenetre=this;
}

Cfenetre::~Cfenetre()
{
    delete[] this->msg;
    delete[] this->caption;
}

//*****************************************************************************/
//                   GETTERS 
//*****************************************************************************/
HINSTANCE Cfenetre::get_owner_instance()
{
    return this->owner_instance;
}
HWND Cfenetre::get_owner_handle()
{
    return this->owner_handle;
}
char* Cfenetre::get_msg()
{
    return this->msg;
}

char* Cfenetre::get_caption()
{
    return this->caption;
}
DWORD Cfenetre::get_idd_dialog()
{
    return this->dw_idd_dialog;
}
//*****************************************************************************/
//                   SETTERS 
//*****************************************************************************/
void Cfenetre::set_message(char* pc_msg)
{
    delete[] this->msg;
    this->msg=new char[strlen(pc_msg)+1];
    strcpy(this->msg,pc_msg);

    if (this->dialogbox_handle!=NULL)
    {
        HWND hwndStatic;
        hwndStatic = GetDlgItem(this->dialogbox_handle, IDD_STATIC);
        SendMessage(hwndStatic, WM_SETTEXT, 0,(LPARAM) this->msg);
    }
}

void Cfenetre::set_caption(char* pc_msg)
{
    delete[] this->caption;
    this->caption=new char[strlen(pc_msg)+1];
    strcpy(this->caption,pc_msg);

    if (this->dialogbox_handle!=NULL)
    {
        SendMessage(dialogbox_handle, WM_SETTEXT, 0,(LPARAM) this->caption);
    }
}

void Cfenetre::set_idd_dialog(DWORD idd_dialog)
{
    this->dw_idd_dialog=idd_dialog;
}

/* @FNT( **********************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     FONCTION : close_dialog_box                                  ******/
/******                                                                  ******/
/******************************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     Description :                                                ******/
/******     -----------                                                  ******/
/******     femeture de la boite de dialogue                             ******/
/******************************************************************************/
/******                                                                  ******/
/******     Paramtre(s) en entre :                                     ******/
/******     ----------------------                                       ******/
/******************************************************************************/
/******                                                                  ******/
/******     paramtres en sortie :                                       ******/
/******     --------------------                                         ******/
/******************************************************************************/
/******                                                                  ******/
/******     valeur retourne :                                           ******/
/******     ------------------                                           ******/
/******************************************************************************/
/* @FNT) **********************************************************************/
void Cfenetre::close_dialog_box()
{
    /*
    BOOL EndDialog(
      HWND hDlg,        // handle to dialog box
      INT_PTR nResult   // value to return
    );
    */
    if (this->dialogbox_handle!=NULL)
    {
        EndDialog(this->dialogbox_handle,ERROR_SUCCESS);
    }
}

