/* @ENF( **********************************************************************/
/******************************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     Nom du logiciel                                              ******/
/******     Nom du projet                                                ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******   Fichier : Cfenetre_progres.cpp                                 ******/
/******   Version : 1.0                                                  ******/
/******   Date cration:28/03/2002     Date dernire modif. : xx/xx/xxxx ******/
/******                                                                  ******/
/******   Liste des composants :                                         ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******                 "copyright, MBDA, 2000 - 2003"                   ******/
/******                                                                  ******/
/******                                                                  ******/
/****** "Ce logiciel est la proprit de MBDA. Il ne peut tre ni        ******/
/******  communiqu  des tiers ni utilis sans autorisation pralable   ******/
/******  crite de MBDA. Son contenu ne peut tre divulgu".             ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******     Description fonctionnelle :                                  ******/
/******     -------------------------                                    ******/
/******                                                                  ******/
/******	    Ce fichier contient la classe Cfenetre_progres               ******/
/******     affiche un boite de dialogue non modale pour faire patienter ******/
/******                                                                  ******/
/******************************************************************************/
/******                                                                  ******/
/******     Historique :                                                 ******/
/******     ----------                                                   ******/
/******                                                                  ******/
/******************************************************************************/
/******   28/03/2003              Version   1.0                          ******/
/******   Auteur :Jacquelin POTIER Service : M/O/ES/DB/LS                ******/
/******                                                                  ******/
/******   Cration                                                       ******/
/******                                                                  ******/
/******************************************************************************/
/******   xx/xx/yyyy              Version   1.1                          ******/
/******   auteur : ........       Service : ........                     ******/
/******                                                                  ******/
/******       description de la (des)modification(s)                     ******/
/****** ................................................................ ******/
/****** ................................................................ ******/
/******                                                                  ******/
/******************************************************************************/
/******************************************************************************/
/* @ENF) **********************************************************************/
#include "stdafx.h"
#include "Cfenetre_progres.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Cfenetre_progres::Cfenetre_progres()
{
    this->set_message("Veuillez patienter durant le transfert des donnes");
    this->dw_idd_dialog=IDD_DIALOG_PROGRES;
}

Cfenetre_progres::Cfenetre_progres(HINSTANCE hi_hInstance,HWND h_owner_handle):Cfenetre(hi_hInstance,h_owner_handle,IDD_DIALOG_PROGRES)
{
    this->set_message("Veuillez patienter durant le transfert des donnes");
}

Cfenetre_progres::~Cfenetre_progres()
{
}


/* @FNT( **********************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     FONCTION : show_dialog_box                                   ******/
/******                                                                  ******/
/******************************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     Description :                                                ******/
/******     -----------                                                  ******/
/******     affichage de la boite de dialogue dans un nouveau thread     ******/
/******     pour avoir une boite de dialogue non modal                   ******/
/******************************************************************************/
/******                                                                  ******/
/******     Paramtre(s) en entre :                                     ******/
/******     ----------------------                                       ******/
/******************************************************************************/
/******                                                                  ******/
/******     paramtres en sortie :                                       ******/
/******     --------------------                                         ******/
/******************************************************************************/
/******                                                                  ******/
/******     valeur retourne :                                           ******/
/******     ------------------                                           ******/
/******************************************************************************/
/* @FNT) **********************************************************************/
int Cfenetre_progres::show_dialog_box()
{
    HANDLE      hThreadCom;
    DWORD       dwThreadId;
    hThreadCom = CreateThread( NULL,                      // pointer to thread security attributes
                               0,                         // initial thread stack size, in bytes
                               fcreate_dialog_box,         // pointer to thread function
                               (LPVOID)this,                         // argument for new thread
                               0,                         // creation flags
                               &dwThreadId);              // pointer to returned thread identifier

    //si le thread n'a pas demarr
    if (hThreadCom == NULL)
    {
        return ERR_CREATE_THREAD;
    }

    SetThreadPriority( hThreadCom,					// handle to the thread
                       THREAD_PRIORITY_NORMAL);  	// thread priority level
    return ERROR_SUCCESS;
}

/* @FNT( **********************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     FONCTION : fcreate_dialog_box                                ******/
/******                                                                  ******/
/******************************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     Description :                                                ******/
/******     -----------                                                  ******/
/******     creation de la boite de dialogue                             ******/
/******************************************************************************/
/******                                                                  ******/
/******     Paramtre(s) en entre :                                     ******/
/******     ----------------------                                       ******/
/******************************************************************************/
/******                                                                  ******/
/******     paramtres en sortie :                                       ******/
/******     --------------------                                         ******/
/******************************************************************************/
/******                                                                  ******/
/******     valeur retourne :                                           ******/
/******     ------------------                                           ******/
/******************************************************************************/
/* @FNT) **********************************************************************/
unsigned long WINAPI fcreate_dialog_box(void* vobj)
{
    Cfenetre_progres* obj=(Cfenetre_progres*)vobj;
    DialogBox(obj->get_owner_instance() , (LPCTSTR)IDD_DIALOG_PROGRES, obj->get_owner_handle() , (DLGPROC)call_back_dialog_progress);
    return ERROR_SUCCESS;
}


/* @FNT( **********************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     FONCTION : call_back_dialog_progress                         ******/
/******                                                                  ******/
/******************************************************************************/
/******************************************************************************/
/******                                                                  ******/
/******     Description :                                                ******/
/******     -----------                                                  ******/
/******     callback pour la boite de dialogue                           ******/
/******************************************************************************/
/******                                                                  ******/
/******     Paramtre(s) en entre :                                     ******/
/******     ----------------------                                       ******/
/******************************************************************************/
/******                                                                  ******/
/******     paramtres en sortie :                                       ******/
/******     --------------------                                         ******/
/******************************************************************************/
/******                                                                  ******/
/******     valeur retourne :                                           ******/
/******     ------------------                                           ******/
/******************************************************************************/
/* @FNT) **********************************************************************/
LRESULT CALLBACK call_back_dialog_progress(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
// si on retourne true le message n'est pas trait par la suite
{
    UNREFERENCED_PARAMETER(lParam);
    UNREFERENCED_PARAMETER(wParam);

    switch (message)
    {
    case WM_INITDIALOG:
        g_fen_Cfenetre->dialogbox_handle=hDlg;
        g_hwnd_current_dialog_box=hDlg;
        HWND hwndStatic;
        hwndStatic = GetDlgItem(g_fen_Cfenetre->dialogbox_handle, IDD_STATIC);
        SendMessage(hwndStatic, WM_SETTEXT, 0,(LPARAM) g_fen_Cfenetre->get_msg());
        return FALSE;

    default:
        return FALSE;
    }

    //return FALSE;
}

